c! Eric springs
c! 
c!
        implicit none

        character*100 :: infile,outfile,header,coutfile
 
        integer ::  ol,oz,om,oat,da,db,dc,dl,dz,dm,dat
        integer ::  rows,newtype,typemax
        real    :: newlength,thresh,ericarg

        integer :: type_table(2,30)
        integer :: rows_in_table,i,j,ata,atb
        real :: vdw_radius(3),sprcons(10000)

c! OK, now, store Eric's parameters:
          real, parameter :: A = 11.00, B = -0.40, C =  8.00

        rows_in_table = 28

         sprcons = -99999

c!       Notes:
c!       C = atom type 1
c!       Cl = 2
c!       H = 3
c!       x = 4

        vdw_radius(1) = 1.7
        vdw_radius(2) = 1.75
        vdw_radius(3) = 1.2

c! zmat1 is with_CH3_1.zmat
c! zmat2 is with_CH3_2.zmat

c!  First, set all to 'C' (1) since they are most common:

        do i = 1,rows_in_table
        do j = 1,2
           type_table(j,i)=1
        end do
        end do

c! Now set the Cl
           type_table(1,21) = 2
           type_table(2,20) = 2

c! Now set the H
        do i = 22,28
        do j = 1,2
           type_table(j,i)=3
        end do
        end do
        do i = 16,19
        do j = 1,2
           type_table(j,i)=3
        end do
        end do

c! write it out
         
c!        do i = 1,28
c!           write(6,*)(type_table(j,i),j=1,2)
c!        end do
        
c! read in the contacts list


       write(6,*)'Assumes contacts are already classified as per'
       write(6,*)'classify_v2.f, i.e.:'
       write(6,*)'ascending order by length, and within that that'
       write(6,*)'that they have been sorted by oz and within'
       write(6,*)'that by dz.  Assumes om=dm=1 always !!!!'
       write(6,*)'This is for CMA mono only!!!'
       write(6,*)'Feb 2015, Darren Goossens.'

       write(6,*)'Infile?'
       read(5,*)infile
       write(6,*)'Outfile? (sprcons written here)'
       read(5,*)outfile
       write(6,*)'Outfile? (trimmmed contacts written here)'
       read(5,*)coutfile
       write(6,*)'Reading ',trim(infile),', writing to ',trim(outfile)
       write(6,*)'How many rows?' 
       read(5,*)rows

c! This bit is just for the CMA mono initial tests
       if(rows.lt.0)rows=6000

       write(6,*)rows,' rows.'
       open(unit=1,file=infile) 
       open(unit=2,file=coutfile)
       read(1,'(a100)')header
       write(2,'(a100)')header
       write(6,*)
       write(6,*)'Header is...'
       write(6,*)header
       typemax = -1000
          do i = 1,rows
             read(1,*)ol,oz,om,oat,da,db,dc,dl,dz,dm,dat,
     &         newlength,newtype
!             write(6,'(11i3,x,f6.4,2i6)')ol,oz,om,oat,da,db,dc,dl,dz,dm,
!     &              dat,newlength,newtype
                     ata = type_table(oz,oat)
                     atb = type_table(dz,dat)
             ericarg = newlength - vdw_radius(ata) - vdw_radius(atb)
             sprcons(newtype) =  A * exp ( B * (ericarg) ) - C
             if(newtype.gt.typemax)typemax=newtype
             if(sprcons(newtype).gt.0.0) then
                write(2,'(11i3,x,f6.4,2i6)')ol,oz,om,oat,da,db,dc,
     &               dl,dz,dm,
     &              dat,newlength,newtype
             end if

          end do
       close(2)
       close(1)
       open(unit=2,file=outfile) 
            write(2,*)'Trimmed'
            do i = 1,typemax
               if(sprcons(i).gt.0.0)
     &     write(2,*)'SPRCON ',max(0.0,sprcons(i)),i
            end do
            write(2,*)'Untrimmed'
            do i = 1,typemax
               write(2,*)'SPRCON ',max(0.0,sprcons(i)),i
            end do
       close(2)
       stop

       end program 
