module myparams
  !Integer Parameters!
  integer, parameter:: maxatom = 10       !max number of atoms per cell
  integer, parameter:: maxtypes = 100      !max number of atom types
  integer, parameter:: maxdim  = 100       !max number of cells per dimension
  integer, parameter:: maxcor  = 20        !max number of correlation types
  integer, parameter:: maxneigh= 20        !max number of neighbours of a type
end module myparams



       program classify

  use myparams

       implicit none
       
       character*100 :: vecfile, infile, outfile,header
       integer ::  rows,newtype,i,dummy,oldtype,increment
       real    :: newlength,oldlength,thresh, E1, E2,rocc1,rocc2,roccd,temp1
  integer                              :: occ1, occ2, itemp

       integer,dimension(321) :: ol,oz,om,oat,da,db,dc,dl
       integer,dimension(321) ::dz,dm,dat,vectype
       real,dimension(321) :: length
       real,dimension(maxcor) :: corr, flags, const

       integer :: simsize(3), numlocs,j,k,l,ii,jj,kk,ll,zz,i1,i2
       integer,dimension(4) :: onecell, twocell,dcell

       integer :: occ(maxdim,maxdim,maxdim,maxatom),numvec,isite
       integer :: wrap(3,-(maxdim-1):2*maxdim),cycles,iouter,inner
       integer :: up, acc, rej

       real ::r(1)

       vectype = -999

       thresh = 0.005

       write(6,*)'Occ MC'
       write(6,*)'For CMA mono, two zmats 1 and 2.'
       write(6,*)'occ vectors determined using ZMC on an artificial'
       write(6,*)'_origin_ atom.  Step one is read in these vectors'
       write(6,*)'step 2 is read in an exisiting occupany structure'
       write(6,*)'step 3 is read in the desired correlations'
       write(6,*)'step 4 is do the MC'
       write(6,*)'Feb/Mar 2015'

        i1 = 11211
        i2 = 21311

       write(6,*)'Random number seeds are ',i1,i2
       call rseed(i1,i2)


       write(6,*)'File of vectors?'
       read(5,*)vecfile
       write(6,*)'Exisiting occupancy structure file'
       read(5,*) infile
       write(6,*)'Outfile?'
       read(5,*) outfile
       write(6,*)'Reading ',trim(infile),' to ',trim(outfile)
       write(6,*)'How many vectors in list?'
       read(5,*)rows
!c This bit is just for the CMA mono initial tests
       if(rows.lt.0)rows=108
       write(6,*)rows,' rows.'
!c Here we read in the contact vectors
       write(6,*)'opening vector file',trim(vecfile) 
       open(unit=1,file=vecfile) 
       read(1,'(a100)')header
       do i = 1,rows
          read(1,*)ol(i),oz(i),om(i),oat(i),da(i),db(i),dc(i),   &
                  dl(i),dz(i),dm(i),dat(i),length(i),vectype(i)
          write(6,*)i,vectype(i)
       end do 
       close(1)





!c read in the occ structure 
       write(6,*) 'reading in the occ structure'
       write(6,*) 'probably made using Makeocc'

       write(6,*) 'what are crystal dimensions? 4 integers'
       write(6,*) 'a, b, c, locations per cell'
       write(6,*) 'if first integer is negative, will assume 32 32 32 4'
       write(6,*) 'what is a size?'
       read(5,*) simsize(1)
       if (simsize(1).lt.0) then
            do i = 1,3
              simsize(i) = 32
            end do
            numlocs = 4
       else
            write(6,*) 'what is b size?'
            read(5,*) simsize(2)
            write(6,*) 'what is c size?'
            read(5,*) simsize(3)
            write(6,*) 'what is num loc?'
            read(5,*) numlocs
       end if
        write(6,*)'simn dims:',simsize,numlocs
       open(unit=1,file=infile) 
         do i = 1,simsize(1)
         do j = 1,simsize(2)
         do k = 1,simsize(3)
         do l = 1,numlocs
           read(1,*)ii,jj,kk,ll,zz
           occ(ii,jj,kk,ll)=zz
         end do
         end do
         end do
         end do
       close(1)

!c OK, here we have to read in the correlations we want for the
!c various vectors.
  
       numvec = maxval(vectype)
       write(6,*)'Number of vector types in total: ',numvec

       write(6,*) 'We assume overall occupany is set by the'
       write(6,*) 'input file, so what values do you want'
       write(6,*) 'for these correlations?'
       read(5,*)(corr(i),i=1,numvec)
       write(6,*) 'refinement flags (1 or 0)'
       read(5,*)(flags(i),i=1,numvec)

       const = 0.0
       do i = 1,numvec
           if(flags(i).eq.1)then
            write(6,*)i," will be refined to",corr(i)
            const(i) = -1.0
           end if
       end do

       write(6,*)'Fill wrapping arrays'

       j = 0
       do k = 1,3
          do i=-(simsize(k)-1),simsize(k)*2
            j=j+1
            wrap(k,i)=j
       !         write(6,*)k,i,j
            if (j.eq.simsize(k)) j=0
          end do
        end do

!c OK, here we have read in the correlations
!c and the vectors and the array -- ready to go!
!c so... steal some code from one of my other occ MC progs...
!c How about Pb12/simple_ising_Pb12.f90

        write(6,*)'How many MC cycles?'
        read(5,*)cycles
        write(6,*)cycles,' cycles.'


      write(6,*)'Initial state is.......'
     call adjust(occ,wrap,corr,const,da,db,dc,dl,ol,rows,   &
                      vectype,simsize,numlocs,flags)

  ! Start the business!
  do iouter = 1,cycles
     up = 0
     acc = 0
     rej = 0
     write(6,*)'Cycle',iouter
     do inner = 1,simsize(1)*simsize(2)*simsize(3)
        ! select two sites of different value
        do i = 1,3
           call rannum(r,1)   
           onecell(i) = int(r(1)*simsize(i))+1
        end do
           call rannum(r,1)   
           onecell(4) = int(r(1)*numlocs)+1
101     do i = 1,3
           call rannum(r,1)   
           twocell(i) = int(r(1)*simsize(i))+1
        end do
           twocell(4) =  onecell(4)
        occ1 = occ(onecell(1),onecell(2),onecell(3),onecell(4))
        occ2 = occ(twocell(1),twocell(2),twocell(3),twocell(4))
        if(occ1.eq.occ2) goto 101
        ! put onto -1, 1 variables
         rocc1 = -2.*real(occ1)+3.0
         rocc2 = -2.*real(occ2) + 3.0


        E1 = 0.

           do j = 1,rows
              if(ol(j).eq.onecell(4)) then
                dcell(1) = wrap(1,onecell(1)+da(j))
                dcell(2) = wrap(2,onecell(2)+db(j))
                dcell(3) = wrap(3,onecell(3)+dc(j))
                roccd = -2.0*real(occ(dcell(1),dcell(2),dcell(3),dl(j)))+3.0
                E1 = E1 + const(vectype(j)) * rocc1 * roccd
              end if
              if(ol(j).eq.twocell(4)) then
                dcell(1) = wrap(1,twocell(1)+da(j))
                dcell(2) = wrap(2,twocell(2)+db(j))
                dcell(3) = wrap(3,twocell(3)+dc(j))
                roccd = -2.0*real(occ(dcell(1),dcell(2),dcell(3),dl(j)))+3.0
                E1 = E1 + const(vectype(j)) * rocc2 * roccd
              end if
           end do

        ! Swap
        temp1 = rocc2
        rocc2 = rocc1
        rocc1 = temp1
        E2 = 0.

           do j = 1,rows
              if(ol(j).eq.onecell(4)) then
                dcell(1) = wrap(1,onecell(1)+da(j))
                dcell(2) = wrap(2,onecell(2)+db(j))
                dcell(3) = wrap(3,onecell(3)+dc(j))
                roccd = -2.0*real(occ(dcell(1),dcell(2),dcell(3),dl(j)))+3.0
                E2 = E2 + const(vectype(j)) * rocc1 * roccd
              end if
              if(ol(j).eq.twocell(4)) then
                dcell(1) = wrap(1,twocell(1)+da(j))
                dcell(2) = wrap(2,twocell(2)+db(j))
                dcell(3) = wrap(3,twocell(3)+dc(j))
                roccd = -2.0*real(occ(dcell(1),dcell(2),dcell(3),dl(j)))+3.0
                E2 = E2 + const(vectype(j)) * rocc2 * roccd
              end if
           end do

        ! MC
        if(E2.lt.E1) then
           acc = acc +1
           itemp = occ(onecell(1),onecell(2),onecell(3),onecell(4))
           occ(onecell(1),onecell(2),onecell(3),onecell(4)) =       &
                occ(twocell(1),twocell(2),twocell(3),twocell(4))
           occ(twocell(1),twocell(2),twocell(3),twocell(4)) = itemp
        else
           call rannum(r,1)
           if (exp(E1-E2).gt.r(1)) then
              up = up +1
           itemp = occ(onecell(1),onecell(2),onecell(3),onecell(4))
           occ(onecell(1),onecell(2),onecell(3),onecell(4)) =       &
                occ(twocell(1),twocell(2),twocell(3),twocell(4))
           occ(twocell(1),twocell(2),twocell(3),twocell(4)) = itemp
           else
             rej = rej + 1
           end if
       end if

     end do
     write(6,*)'acc, up, rej, rej/total',acc,up,rej,real(rej)/real(acc+up+rej)
     call adjust(occ,wrap,corr,const,da,db,dc,dl,ol,rows,     &
                      vectype,simsize,numlocs,flags)
  end do




! Write out the array
       open(unit=2,file=outfile) 
         do i = 1,simsize(1)
         do j = 1,simsize(2)
         do k = 1,simsize(3)
         do l = 1,numlocs
           write(2,*)i,j,k,l,occ(i,j,k,l),1
         end do
         end do
         end do
         end do
       close(1)
       stop

       end program 



subroutine adjust(occ,wrap,corr,const,da,db,dc,dl,ol,rows,    &
                      vectype,simsize,numlocs,flags)

  use myparams
  implicit none

  integer, dimension(3)                :: simsize
  integer, dimension(maxdim,maxdim,maxdim,maxatom)::occ
       integer,dimension(321) :: vectype
  real,dimension(maxcor)               :: corr, const,corrcalc
       real,dimension(maxcor) ::  flags
  integer                              :: rows,numlocs,l
  integer,dimension(321)   :: da,db,dc,dl,ol
  integer                              ::  ncorr
  integer                              :: wrap(3,-(maxdim-1):2*maxdim)
  real, dimension(maxcor)              :: totalx, totalxsq, totaly, totalysq
  real, dimension(maxcor)              :: totalxy, countsx, countsy
  real                                 :: varx, vary, covar, delta
  integer                              :: icorr,i,j,k,v1,v2,neigh,ii,jj,kk

  ! By doing a 'full' correlation calc (not assuming 0,1 variables, for
  ! example) we can ignore the actual values of the variables, which
  ! is handy if they are atoms 3 and 7 for example.

  ! get all the totals we need

  totalx = 0. 
  totaly = 0. 
  totalysq = 0. 
  totalxsq = 0. 
  totalxy = 0. 
  countsx = 0. 
  countsy = 0. 

     ncorr= maxval(vectype)
     do i = 1, simsize(1)
        do j = 1, simsize(2)
           do k = 1, simsize(3)
            do l = 1,numlocs
              v1 = occ(i,j,k,l)
              do neigh = 1, rows
                 if(l.eq.ol(neigh)) then
!c We are looking at an interaction with the location in question so go ahead
                 icorr = vectype(neigh)
                 ii = wrap(1,i+da(neigh)) 
                 jj = wrap(2,j+db(neigh)) 
                 kk = wrap(3,k+dc(neigh)) 
                 v2 = occ(ii,jj,kk,dl(neigh))
              countsx(icorr) = countsx(icorr)+1.
              totalx(icorr) = totalx(icorr) + real(v1)
              totalxsq(icorr) = totalxsq(icorr) + real(v1**2)
                 countsy(icorr) = countsy(icorr)+1.
                 totaly(icorr) = totaly(icorr) + real(v2)
                 totalxy(icorr) = totalxy(icorr) + real(v1*v2)
                 totalysq(icorr) = totalysq(icorr) + real(v2**2)
                 end if
              end do
           end do
           end do
        end do
     end do

  do icorr = 1,ncorr
     varx = totalxsq(icorr)/countsx(icorr) - (totalx(icorr)/countsx(icorr))**2.0     
     vary = totalysq(icorr)/countsy(icorr) - (totaly(icorr)/countsy(icorr))**2.0     
     covar = totalxy(icorr)/countsy(icorr) - (totaly(icorr)/countsy(icorr))*(totalx(icorr)/countsx(icorr))
     corrcalc(icorr) = covar/sqrt(varx*vary)
     delta=(corr(icorr)-corrcalc(icorr))
     const(icorr)=const(icorr)-delta*flags(icorr)
  end do

  write(6,*) '3 rows; corr; corrcalc; const (const= -1.000 means not refined)'

  write(6,'(a11,f6.3)',advance='no')'Corr (set) ',corr(1)
  do i = 2,ncorr-1
     write(6,'(f6.3)',advance='no')corr(i)
  end do
     write(6,'(f6.3)')corr(ncorr)

  write(6,'(a11,f6.3)',advance='no')'Corr (calc)',corrcalc(1)
  do i = 2,ncorr-1
     write(6,'(f6.3)',advance='no')corrcalc(i)
  end do
     write(6,'(f6.3)')corrcalc(ncorr)

  write(6,'(a11,f6.1)',advance='no')'Constant.  ',const(1)
  do i = 2,ncorr-1
     write(6,'(f6.1)',advance='no')const(i)
  end do
     write(6,'(f6.1)')const(ncorr)

  return

end subroutine adjust

