@echo off
REM Manual compile of ZMC, DZMC and toolbox programs.
REM dependencies are accounted for by the order of the
REM compilations -- some modules depend on others.
REM This means that this could be broken by upstream changes
REM to the modules by Aidan Heerdegen (aidan@rsc.anu.edu.au)
REM
REM However, if this does not happen, compilation is simple.
REM
REM NOTE!!: Some manual customisation of this file will
REM probably be needed, but it is very simple:
REM
REM Namely the -I and -L flags to g95 need to point
REM to the directory where the compilation is happening,
REM and that it is easiest for a relatively simple project
REM like this to use the flat structure, then just copy out
REM the executables to a directory in the path.
REM
REM Seems to work pretty much effortlessly as long as the g95
REM compile environment is working properly.  ALSO this uses the
REM minGW version of g95 running from CMD or COMMAND line, _not_
REM the cygwin version.  Having said that, the cygwin version
REM of g95 should also work without any hassles, the only issue becomes
REM one of portability of the resulting binaries.
REM
REM This is a DOS version of a similar shell script that has been used
REM to compile ZMC for Mac OS X and Linux of various flavours.
REM
REM  goossens@rsc.anu.edu.au, 06 Aug 2012

echo on
del *.o
del *.mod

g95 -O2 -ffree-line-length-huge -c fundamental_constants.f90
g95 -O2 -ffree-line-length-huge -c varying_string.f90
g95 -O2 -ffree-line-length-huge -c globals.f90
g95 -O2 -ffree-line-length-huge -c precision.f90
g95 -O2 -ffree-line-length-huge -c cartesian_class.f90
g95 -O2 -ffree-line-length-huge -c array_functions.f90

g95 -O2 -ffree-line-length-huge -c sort_functions.f90
g95 -O2 -ffree-line-length-huge -c variable_array.f90
g95 -O2 -ffree-line-length-huge -c binary.f90

g95 -O2 -ffree-line-length-huge -c string_functions.f90
g95 -O2 -ffree-line-length-huge -c statistics.f90

g95 -O2  -ffree-line-length-huge -c binary_io.f90

g95 -O2 -ffree-line-length-huge -c file_functions.f90

g95 -O2 -ffree-line-length-huge -c hash_table.f90
g95 -O2 -ffree-line-length-huge -c polysample.f90
g95 -O2 -ffree-line-length-huge -c vector_class.f90

g95 -O2 -ffree-line-length-huge -c mol2_class.f90
g95 -O2 -ffree-line-length-huge -c cmdline_arguments.f90
g95 -O2 -ffree-line-length-huge -c keyword_class.f90
g95 -O2 -ffree-line-length-huge -c rotmatrix_class.f90

g95 -O2 -ffree-line-length-huge -c crystallography_class.f90
g95 -O2 -ffree-line-length-huge -c image_transforms.f90
g95 -O2 -ffree-line-length-huge -c quaternion_class.f90
g95 -O2 -ffree-line-length-huge -c zmatrix_class.f90

g95 -O2 -ffree-line-length-huge -c pnm_class.f90
g95 -O2 -ffree-line-length-huge -c superimpose.f90
     
g95 -O2 -fstatic -mno-cygwin  -o ZMC.exe  zmc_Aug24_2012.f90 rannum.f ps_routines.f fundamental_constants.o varying_string.o globals.o precision.o cartesian_class.o array_functions.o sort_functions.o variable_array.o binary.o binary_io.o string_functions.o statistics.o file_functions.o hash_table.o polysample.o vector_class.o mol2_class.o cmdline_arguments.o keyword_class.o rotmatrix_class.o crystallography_class.o image_transforms.o quaternion_class.o zmatrix_class.o superimpose.o pnm_class.o
g95 -O2 -fstatic -mno-cygwin  -o DZMC.exe readat_zmc_April20_2011.f90 diffuse_allocatable.f90 rannum.f  ps_routines.f fundamental_constants.o varying_string.o globals.o precision.o cartesian_class.o array_functions.o sort_functions.o variable_array.o binary.o binary_io.o string_functions.o statistics.o file_functions.o hash_table.o polysample.o vector_class.o mol2_class.o cmdline_arguments.o keyword_class.o rotmatrix_class.o crystallography_class.o image_transforms.o quaternion_class.o zmatrix_class.o superimpose.o pnm_class.o
g95 -O2 -fstatic -mno-cygwin  -o bin2gray.exe  bin2gray_win32.f90   ps_routines.f fundamental_constants.o varying_string.o globals.o precision.o cartesian_class.o array_functions.o sort_functions.o variable_array.o binary.o binary_io.o string_functions.o statistics.o file_functions.o hash_table.o polysample.o vector_class.o mol2_class.o cmdline_arguments.o keyword_class.o rotmatrix_class.o crystallography_class.o image_transforms.o quaternion_class.o zmatrix_class.o superimpose.o pnm_class.o 
g95 -O2 -fstatic -mno-cygwin  -o zmat_maker.exe zmat_maker.f90   ps_routines.f fundamental_constants.o varying_string.o globals.o precision.o cartesian_class.o array_functions.o sort_functions.o variable_array.o binary.o binary_io.o string_functions.o statistics.o file_functions.o hash_table.o polysample.o vector_class.o mol2_class.o cmdline_arguments.o keyword_class.o rotmatrix_class.o crystallography_class.o image_transforms.o quaternion_class.o zmatrix_class.o superimpose.o pnm_class.o 
g95 -O2 -fstatic -mno-cygwin  -o zmat2xyz.exe zmat2xyz.f90   ps_routines.f fundamental_constants.o varying_string.o globals.o precision.o cartesian_class.o array_functions.o sort_functions.o variable_array.o binary.o binary_io.o string_functions.o statistics.o file_functions.o hash_table.o polysample.o vector_class.o mol2_class.o cmdline_arguments.o keyword_class.o rotmatrix_class.o crystallography_class.o image_transforms.o quaternion_class.o zmatrix_class.o superimpose.o pnm_class.o 
g95 -O2 -fstatic -mno-cygwin  -o zmatchk.exe zmatchk.f90   ps_routines.f fundamental_constants.o varying_string.o globals.o precision.o cartesian_class.o array_functions.o sort_functions.o variable_array.o binary.o binary_io.o string_functions.o statistics.o file_functions.o hash_table.o polysample.o vector_class.o mol2_class.o cmdline_arguments.o keyword_class.o rotmatrix_class.o crystallography_class.o image_transforms.o quaternion_class.o zmatrix_class.o superimpose.o pnm_class.o 
g95 -O2 -fstatic -mno-cygwin  -o zmat_anim.exe zmat_anim.f90   ps_routines.f fundamental_constants.o varying_string.o globals.o precision.o cartesian_class.o array_functions.o sort_functions.o variable_array.o binary.o binary_io.o string_functions.o statistics.o file_functions.o hash_table.o polysample.o vector_class.o mol2_class.o cmdline_arguments.o keyword_class.o rotmatrix_class.o crystallography_class.o image_transforms.o quaternion_class.o zmatrix_class.o superimpose.o pnm_class.o 
g95 -O2 -fstatic -mno-cygwin  -o zmat2mol2.exe zmat2mol2.f90   ps_routines.f fundamental_constants.o varying_string.o globals.o precision.o cartesian_class.o array_functions.o sort_functions.o variable_array.o binary.o binary_io.o string_functions.o statistics.o file_functions.o hash_table.o polysample.o vector_class.o mol2_class.o cmdline_arguments.o keyword_class.o rotmatrix_class.o crystallography_class.o image_transforms.o quaternion_class.o zmatrix_class.o superimpose.o pnm_class.o 
g95 -O2 -fstatic -mno-cygwin  -o pgmave.exe pgmave.f90   ps_routines.f fundamental_constants.o varying_string.o globals.o precision.o cartesian_class.o array_functions.o sort_functions.o variable_array.o binary.o binary_io.o string_functions.o statistics.o file_functions.o hash_table.o polysample.o vector_class.o mol2_class.o cmdline_arguments.o keyword_class.o rotmatrix_class.o crystallography_class.o image_transforms.o quaternion_class.o zmatrix_class.o superimpose.o pnm_class.o 
g95 -O2 -fstatic -mno-cygwin  -o pgmcombine.exe pgmcombine.f90   ps_routines.f fundamental_constants.o varying_string.o globals.o precision.o cartesian_class.o array_functions.o sort_functions.o variable_array.o binary.o binary_io.o string_functions.o statistics.o file_functions.o hash_table.o polysample.o vector_class.o mol2_class.o cmdline_arguments.o keyword_class.o rotmatrix_class.o crystallography_class.o image_transforms.o quaternion_class.o zmatrix_class.o superimpose.o pnm_class.o 
g95 -O2 -fstatic -mno-cygwin  -o make_random_occ.exe make_random_occ.f90 rannum.f  ps_routines.f fundamental_constants.o varying_string.o globals.o precision.o cartesian_class.o array_functions.o sort_functions.o variable_array.o binary.o binary_io.o string_functions.o statistics.o file_functions.o hash_table.o polysample.o vector_class.o mol2_class.o cmdline_arguments.o keyword_class.o rotmatrix_class.o crystallography_class.o image_transforms.o quaternion_class.o zmatrix_class.o superimpose.o pnm_class.o 
g95 -O2 -fstatic -mno-cygwin  -o mol2xyz.exe mol2xyz.f90   ps_routines.f fundamental_constants.o varying_string.o globals.o precision.o cartesian_class.o array_functions.o sort_functions.o variable_array.o binary.o binary_io.o string_functions.o statistics.o file_functions.o hash_table.o polysample.o vector_class.o mol2_class.o cmdline_arguments.o keyword_class.o rotmatrix_class.o crystallography_class.o image_transforms.o quaternion_class.o zmatrix_class.o superimpose.o pnm_class.o
g95 -O2 -fstatic -mno-cygwin  -o catmol2.exe catmol2.f90   ps_routines.f fundamental_constants.o varying_string.o globals.o precision.o cartesian_class.o array_functions.o sort_functions.o variable_array.o binary.o binary_io.o string_functions.o statistics.o file_functions.o hash_table.o polysample.o vector_class.o mol2_class.o cmdline_arguments.o keyword_class.o rotmatrix_class.o crystallography_class.o image_transforms.o quaternion_class.o zmatrix_class.o superimpose.o pnm_class.o
g95 -O2 -fstatic -mno-cygwin  -o chkmol2.exe chkmol2.f90   ps_routines.f fundamental_constants.o varying_string.o globals.o precision.o cartesian_class.o array_functions.o sort_functions.o variable_array.o binary.o binary_io.o string_functions.o statistics.o file_functions.o hash_table.o polysample.o vector_class.o mol2_class.o cmdline_arguments.o keyword_class.o rotmatrix_class.o crystallography_class.o image_transforms.o quaternion_class.o zmatrix_class.o superimpose.o pnm_class.o
g95 -O2 -fstatic -mno-cygwin  -o pgm2mask.exe pgm2mask.f90   ps_routines.f fundamental_constants.o varying_string.o globals.o precision.o cartesian_class.o array_functions.o sort_functions.o variable_array.o binary.o binary_io.o string_functions.o statistics.o file_functions.o hash_table.o polysample.o vector_class.o mol2_class.o cmdline_arguments.o keyword_class.o rotmatrix_class.o crystallography_class.o image_transforms.o quaternion_class.o zmatrix_class.o superimpose.o pnm_class.o
g95 -O2 -fstatic -mno-cygwin  -o pgm2ni.exe pgm2ni.f90   ps_routines.f fundamental_constants.o varying_string.o globals.o precision.o cartesian_class.o array_functions.o sort_functions.o variable_array.o binary.o binary_io.o string_functions.o statistics.o file_functions.o hash_table.o polysample.o vector_class.o mol2_class.o cmdline_arguments.o keyword_class.o rotmatrix_class.o crystallography_class.o image_transforms.o quaternion_class.o zmatrix_class.o superimpose.o pnm_class.o
g95 -O2 -fstatic -mno-cygwin  -o ni2pgm.exe ni2pgm.f90   ps_routines.f fundamental_constants.o varying_string.o globals.o precision.o cartesian_class.o array_functions.o sort_functions.o variable_array.o binary.o binary_io.o string_functions.o statistics.o file_functions.o hash_table.o polysample.o vector_class.o mol2_class.o cmdline_arguments.o keyword_class.o rotmatrix_class.o crystallography_class.o image_transforms.o quaternion_class.o zmatrix_class.o superimpose.o pnm_class.o
g95 -O2 -fstatic -mno-cygwin  -o raw2pgm.exe raw2pgm.f90   ps_routines.f fundamental_constants.o varying_string.o globals.o precision.o cartesian_class.o array_functions.o sort_functions.o variable_array.o binary.o binary_io.o string_functions.o statistics.o file_functions.o hash_table.o polysample.o vector_class.o mol2_class.o cmdline_arguments.o keyword_class.o rotmatrix_class.o crystallography_class.o image_transforms.o quaternion_class.o zmatrix_class.o superimpose.o pnm_class.o
mkdir ZMCwin
move *.exe ZMCWin
